// (c) 2024 WZP widget-zp.de
if (!window.$wzp) {
    window.$wzp = {};
}
(function () {
    window.$wzp.Accordion = function (sel) {
        if (!document.querySelector('.accordion2022')) return;
        const direction = document.querySelector('.accordion2022').getAttribute('data-direction') ?? '';
        const elements = document.querySelectorAll(sel);
        if (!elements || elements.length == 0 || !('animate' in document.body)) return;

        let delayMs = 100;
        elements.forEach((ele) => {
            const btn = ele.querySelector(':scope > button');
            const content = ele.querySelector(':scope > div');

            content.style.height = 0;

            /* Staggered entry animation */
            ele.animate(
                [
                    {transform: direction === 'right' ? 'translateX(20px)' : direction === 'left' ? 'translateX(-20px)' : 'translateX(0)', opacity: 0},
                    {transform: 'translateX(0)', opacity: 1},
                ],
                {duration: 900, easing: 'ease-in-out', fill: 'both', delay: delayMs}
            );

            btn.addEventListener('click', () => {
                let animation;
                /* open the tab */
                if (!ele.classList.contains('is-active')) {
                    ele.classList.add('is-active');
                    content.style.height = 'unset';
                    animation = content.animate([{height: 0}, {height: content.scrollHeight + 20 + 'px', offset: 0.6}, {height: content.scrollHeight + 'px', offset: 0.85}], {
                        duration: 600,
                        easing: 'ease-in-out',
                    });
                } else {
                    ele.classList.remove('is-active');
                    content.style.height = 0;
                    animation = content.animate([{height: content.scrollHeight + 'px'}, {height: 0}], {duration: 500, easing: 'ease-in-out'});
                }

                animation.addEventListener('finish', () => {
                    if (ele.classList.contains('is-active')) {
                        content.style.height = 'unset';
                    } else {
                        content.style.height = 0;
                    }
                });
            });

            delayMs += 150;
        });
    };

    document.addEventListener('DOMContentLoaded', function () {
        window.$wzp.Accordion('.accordion2022__item');
    });
})();
